{
  description = "Ludus dev flake (rust)";

  inputs.fenix = {
    url = "github:nix-community/fenix";
    inputs.nixpkgs.follows = "nixpkgs";
  };

  outputs = {nixpkgs, fenix, ... }@inputs:
    let
      system = "x86_64-linux"; # your version
      pkgs = nixpkgs.legacyPackages.x86_64-linux;
      fx = fenix.packages.x86_64-linux;
    in
    {
      devShells.${system}.default = pkgs.mkShell rec {
        packages = [
          pkgs.wasm-pack
          (fx.combine [
            fx.latest.cargo
            fx.latest.rustc
            fx.targets.wasm32-unknown-unknown.latest.rust-std
          ])
        ];
      };
    };
}
